#!/usr/bin/perl

use IO::File;

sub CODE { 1; }
sub DATA { 2; }

my $segment = DATA;

# set up temporary file to hold data
my $temp_code = IO::File->new_tmpfile || die "Could not create temporary file: $!";

# process files
while (<>) {
	if (/\/\/ CODE/) { $segment = CODE; }
	elsif (/\/\/ DATA/) { $segment = DATA; }
	elsif (/PREFIX\t(.*)/) { print $_; print $temp_code "$_"; }
	elsif ($segment == DATA) { print $_; }
	elsif ($segment == CODE) { print $temp_code "$_"; }
	else { assert(0); }
}

seek($temp_code, 0, 0) || die "Could not seek on temporary file: $!";
print "9H\tLOC\t8B\t\t\t// CODE\n";
print <$temp_code>;
print "8H\tLOC\t9B\t\t\t// DATA\n";


