/*
 * memio.c -- memory-mapped I/O
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "common.h"
#include "pipe.h"
#include "memio.h"


#define INBUF_SIZE	100


static char buf[INBUF_SIZE];


static Octa readHex(char *p) {
  Octa val;
  int d[INBUF_SIZE];
  int j, k;

  val.h = 0;
  val.l = 0;
  for (j = 0; ; j++) {
    if (p[j] >= '0' && p[j] <= '9') {
      d[j] = p[j] - '0';
    } else
    if (p[j] >= 'a' && p[j] <= 'f') {
      d[j] = p[j] - 'a' + 10;
    } else
    if (p[j] >= 'A' && p[j] <= 'F') {
      d[j] = p[j] - 'A' + 10;
    } else {
      break;
    }
  }
  p[j] = '\0';
  j--;
  for (k = 0; k <= j; k++) {
    if (k >= 8) {
      val.h += d[j - k] << (4 * k - 32);
    } else {
      val.l += d[j - k] << (4 * k);
    }
  }
  return val;
}


Octa memioRead(Octa addr) {
  Octa val;

  if (verbose & IO_READ_BIT) {
    printf("** Read from loc #%08X%08X (enter value in hex): ",
           addr.h, addr.l);
    fgets(buf, INBUF_SIZE, stdin);
    val = readHex(buf);
  } else {
    val.h = 0;
    val.l = 0;
  }
  if (verbose & SHOW_IO_BIT) {
    printf("   (memioRead #%08X%08X from #%08X%08X at time %d)\n",
           val.h, val.l, addr.h, addr.l, ticks.l);
  }
  return val;
}


void memioWrite(Octa addr, Octa val) {
  if (verbose & SHOW_IO_BIT) {
    printf("   (memioWrite #%08X%08X to #%08X%08X at time %d)\n",
           val.h, val.l, addr.h, addr.l, ticks.l);
  }
}
