%
% testing software virtual address translation
% (example from mmix-doc)
%

	LOC	#0000ffff00000000

vinit	OCTA	#0000000000001234
rVinit	OCTA	#32100D0000000001

base	IS	$8
limit	IS	$9
virt	IS	$10
mask	IS	$11
s	IS	$12

Main	JMP	Start

% rV must first be inited with a meaningful value
Start	SETL	virt,#1234	% sample virtual address
	SETH	$1,#3120
	ORMH	$1,#0D00
	ORL	$1,#0001	% sample config for rV (Aplha21064)
	PUT	rV,$1
% usually done: GET virt, rYY
	GET	$7,rV		% $7=rightmost three bits
	AND	$1,$7,#7	% $1=rightmost three bits
	BNZ	$1,Fail		% should be zero
	SRU	$1,virt,61	% $1=i (segment number)
	SLU	$1,$1,2
	NEG	$1,52,$1	% $1=52-4i
	SRU	$1,$7,$1
	SLU	$2,$1,4
	SETL	$0,#f000
	AND	$1,$1,$0	% $1=b[i]<<12
	AND	$2,$2,$0	% $2=b[i+1]<<12
	SLU	$3,$7,24
	SRU	$3,$3,37
	SLU	$3,$3,13	% $3=(r field of rV)
	ORH	$3,#8000	% make $3 a physical address
	2ADDU	base,$1,$3	% base=address of first page table
	2ADDU	limit,$2,$3	% limit=address after last page table
	SRU	s,$7,40
	AND	s,s,#ff		% s=(s field of rV)
	CMP	$0,s,13
	BN	$0,Fail		% s must be 13 or more
	CMP	$0,s,49
	BNN	$0,Fail		% s must be 48 or less
	SETH	mask,#8000
	ORL	mask,#1ff8	% mask=(sign bit and n field)
	ORH	$7,#8000	% set sign bit for PTP validation below
	SRU	$0,virt,s	% $0=a4a3a2a1a0 (page number of virt)
	ZSZ	$1,$0,1		% $1=[page number is zero]
	ADD	limit,limit,$1	% increase limit if page number is zero
% find digits of page number (a4,a3,a2,a1,a0)
% from right to left
	SETL	$6,#3ff		% 10 bits
	SET	$5,base		%
	SRU	$1,$0,10
	PBZ	$1,1F
	AND	$0,$0,$6
	INCL	base,#2000
	SET	$5,base		%
	SRU	$2,$1,10
	PBZ	$2,2F
	AND	$1,$1,$6
	INCL	base,#2000
	SET	$5,base		%
	SRU	$3,$2,10
	PBZ	$3,3F
	AND	$2,$2,$6
	INCL	base,#2000
	SET 	$5,base		%
	SRU	$4,$3,10
	PBZ	$4,4F
	AND	$3,$3,$6
	INCL	base,#2000
% cascade back through PTPs
	SET	$5,base
	8ADDU	$6,$4,base
	LDO	base,$6,0
	XOR	$6,base,$7
	AND	$6,$6,mask
	BNZ	$6,Fail
	ANDNL	base,#1fff	%
4H	8ADDU	$6,$3,base
	LDO	base,$6,0
	XOR	$6,base,$7
	AND	$6,$6,mask
	BNZ	$6,Fail
	ANDNL	base,#1fff	%
3H	8ADDU	$6,$2,base
	LDO	base,$6,0
	XOR	$6,base,$7
	AND	$6,$6,mask
	BNZ	$6,Fail
	ANDNL	base,#1fff	%
2H	8ADDU	$6,$1,base
	LDO	base,$6,0
	XOR	$6,base,$7
	AND	$6,$6,mask
	BNZ	$6,Fail
% obtain PTE
	ANDNL	base,#1fff	% remove low 13 bits of PTP
1H	8ADDU	$6,$0,base
	LDO	base,$6,0	% base=PTE
	XOR	base,base,$7
	ANDN	$6,base,#7
	SLU	$6,$6,51
	BNZ	$6,Fail		% branch if n does not match
	CMP	$6,$5,limit
	BN	$6,Ready	% access beyond page-table?
Fail	SETL	base,0		% errors lead to PTE of zero
	TRAP
Ready	TRAP
% usually put base in rZZ
%Ready	PUT	rZZ,base
%	LDO	$255,IntMask
%	RESUME	1
