%
% rom05.mms -- "crossed" echo with two terminals, polled
%

	LOC	#8000800000000000

Main	SETH	$0,#8001	% set terminal 0 base address
	ORMH	$0,#0000
	SETH	$1,#8001	% set terminal 1 base address
	ORMH	$1,#0001

L1	SYNC	0		% drain pipeline
	LDOU	$2,$0,0		% load terminal 0 receiver status
	AND	$2,$2,1		% check receiver ready
	BZ	$2,L3		% not ready - check terminal 1
	SYNC	0		% drain pipeline
	LDOU	$3,$0,8		% load receiver data

L2	SYNC	0		% drain pipeline
	LDOU	$2,$1,16	% load terminal 1 transmitter status
	AND	$2,$2,1		% check transmitter ready
	BZ	$2,L2		% not ready - loop
	STOU	$3,$1,24	% store char into transmitter data
	SYNCD	7,$1,24		% empty write buffer

L3	SYNC	0		% drain pipeline
	LDOU	$2,$1,0		% load terminal 1 receiver status
	AND	$2,$2,1		% check receiver ready
	BZ	$2,L1		% not ready - check terminal 0
	SYNC	0		% drain pipeline
	LDOU	$3,$1,8		% load receiver data

L4	SYNC	0		% drain pipeline
	LDOU	$2,$0,16	% load terminal 0 transmitter status
	AND	$2,$2,1		% check transmitter ready
	BZ	$2,L4		% not ready - loop
	STOU	$3,$0,24	% store char into transmitter data
	SYNCD	7,$0,24		% empty write buffer

	JMP	L1		% all over again
