%
% rom11.mms -- test TRIP and RESUME with non-negative rX
%

% This program needs at least one page of virtual memory at addr #0.
% Enter e.g. "it #0 #17" and "dt #0 #17" before starting the program.

	LOC	#8000800000000000

Main	SETH	$0,#0000	% b1 = b2 = b3 = b4 = 0
	ORMH	$0,#0E00	% page size is 16k
	ORML	$0,#0000
	ORL	$0,#0001	% asn = 0, VAT by software
	PUT	rV,$0

prog	SETL	$2,#2222
	SETL	$3,#3333
	SETL	$5,#5555
	TRIP	2,3,5		% this should NOT trip...

	SETL	$4,#0000	% copy RESUME instr sequence to loc #0000
	GETA	$2,resume
	LDTU	$1,$2,#00
	STTU	$1,$4,#00
	LDTU	$1,$2,#04
	STTU	$1,$4,#04
	LDTU	$1,$2,#08
	STTU	$1,$4,#08
	LDTU	$1,$2,#0C
	STTU	$1,$4,#0C

	SETL	$4,#1000	% copy TRIP instr sequence to loc #1000
	GETA	$2,prog
	LDTU	$1,$2,#00
	STTU	$1,$4,#00
	LDTU	$1,$2,#04
	STTU	$1,$4,#04
	LDTU	$1,$2,#08
	STTU	$1,$4,#08
	LDTU	$1,$2,#0C
	STTU	$1,$4,#0C
	GETA	$2,stop		% last instr is an endless loop
	LDTU	$1,$2,#00
	STTU	$1,$4,#10

	GO	$4,$4,0		% this should trip...

resume	SETL	$0,#A5A5	% construct instr "SETML $0,#A5A5"
	ORML	$0,#E200
	PUT	rX,$0
	RESUME	0

stop	JMP	stop
